# SPL_CGT_INCLUDE: ../../opt/.splpy/common/py_valueToTuples.cgt
# SPL_CGT_INCLUDE: ../../opt/.splpy/common/py_constructor.cgt
# SPL_CGT_INCLUDE: ../../opt/.splpy/common/py_splTupleToFunctionArgs.cgt
# SPL_CGT_INCLUDE: ../../opt/.splpy/common/py_splTupleCheckForBlobs.cgt
# SPL_CGT_INCLUDE: ../../opt/.splpy/common/py_pyTupleTosplTuple.cgt

package SelectCustomers_cpp;
use strict; use Cwd 'realpath';  use File::Basename;  use lib dirname(__FILE__);  use SPL::Operator::Instance::OperatorInstance; use SPL::Operator::Instance::Annotation; use SPL::Operator::Instance::Context; use SPL::Operator::Instance::Expression; use SPL::Operator::Instance::ExpressionTree; use SPL::Operator::Instance::ExpressionTreeEvaluator; use SPL::Operator::Instance::ExpressionTreeVisitor; use SPL::Operator::Instance::ExpressionTreeCppGenVisitor; use SPL::Operator::Instance::InputAttribute; use SPL::Operator::Instance::InputPort; use SPL::Operator::Instance::OutputAttribute; use SPL::Operator::Instance::OutputPort; use SPL::Operator::Instance::Parameter; use SPL::Operator::Instance::StateVariable; use SPL::Operator::Instance::TupleValue; use SPL::Operator::Instance::Window; 
sub main::generate($$) {
   my ($xml, $signature) = @_;  
   print "// $$signature\n";
   my $model = SPL::Operator::Instance::OperatorInstance->new($$xml);
   unshift @INC, dirname ($model->getContext()->getOperatorDirectory()) . "/../impl/nl/include";
   $SPL::CodeGenHelper::verboseMode = $model->getContext()->isVerboseModeOn();
   print '/*', "\n";
   print ' * # Licensed Materials - Property of IBM', "\n";
   print ' * # Copyright IBM Corp. 2017,2018', "\n";
   print ' */', "\n";
   print "\n";
   SPL::CodeGen::implementationPrologue($model);
   print "\n";
   print "\n";
    my $cmnDir = $model->getContext()->getToolkitDirectory()."/opt/.splpy/common/";
   
    require "splpy_operator.pm";
    require $cmnDir."/splpy.pm";
   
    my @packages = splpy_Packages();
    spl_pip_packages(splpy_PyMajor(), $model, \@packages);
   
    my $module = splpy_Module();
    my $functionName = splpy_FunctionName();
   
     my $skip_set_callable = 0;
    my %cpp_tuple_types;
   print "\n";
   print "\n";
   print 'MY_OPERATOR_SCOPE::MY_OPERATOR::MY_OPERATOR() :', "\n";
   print '    pyop_(NULL)', "\n";
   if ($model->getNumberOfInputPorts() != 0) {
   print "\n";
   print '    ,pyinputfns_(NULL),', "\n";
   print '    pyInNames_(NULL)', "\n";
     for (my $p = 1; $p < $model->getNumberOfInputPorts(); $p++) { 
   print "\n";
   print '    , pyInNames_';
   print $p;
   print '(NULL)', "\n";
   }}
   print "\n";
     for (my $p = 0; $p < $model->getNumberOfOutputPorts(); $p++) { 
   print "\n";
   print '    , pyOutNames_';
   print $p;
   print '(NULL)', "\n";
   }
   print "\n";
   print '{', "\n";
   print '   PyObject * callable;', "\n";
   print '    // Common code for the constructor of SPL Python primitive operators', "\n";
   print '    // that are created from Python functions/callables', "\n";
   print '    // Loads the Python runtime and initializes the function and module variables.', "\n";
       # Initialize splpy.pm
       splpyInit($model);
   print "\n";
   print '    pyop_ = new SplpyPyOp(this);', "\n";
   print '    ', "\n";
   print '    {', "\n";
   print '    SplpyGIL lock;', "\n";
   print "\n";
   print '    // Set the function the operator will call as a member field', "\n";
   print '    callable =', "\n";
   print '      SplpyGeneral::loadFunction("';
   print $module;
   print '", "';
   print $functionName;
   print '");   ', "\n";
   print '     ', "\n";
       if (splpy_OperatorCallable() eq 'class') {
   print "\n";
   print '   { ', "\n";
   print '     // Pass all the arguments by name in a dictionary', "\n";
   print '     // object, effectively as **kwargs. Python will', "\n";
   print '     // unpack correctly to the actual __init__ args', "\n";
   print '     PyObject *empty_tuple = PyTuple_New(0);', "\n";
   print '     PyObject *param_dict = PyDict_New();', "\n";
        for (my $i = 0; $i < $model->getNumberOfParameters(); ++$i) {
            my $tp = $model->getParameterAt($i);
   
            print '{';
            print 'PyObject * param_key = PyUnicode_DecodeUTF8((const char*)  "' . $tp->getName() . '", ((int)(sizeof("' . $tp->getName() . '")))-1 , NULL);';
   
            # cardinality == 1
            print 'PyObject * param_value = ' .
                 convertToPythonValueFromExpr(
                    $tp->getValueAt(0)->getSPLType(),
                    $tp->getValueAt(0)->getCppExpression()) . ";\n";
   
            print " PyDict_SetItem(param_dict, param_key, param_value);\n";
            print " Py_DECREF(param_key);\n";
            print " Py_DECREF(param_value);\n";
            print "}\n";
        }
   print "\n";
   print "\n";
   print '     // At this point callable is the callable class object', "\n";
   print '     // we call it to create an instance of the class', "\n";
   print '     // (which itself is callable)', "\n";
   print "\n";
   print '     // Make the operator pointer (opc) available to', "\n";
   print '     // the __init__ method.', "\n";
   print '     SplpyGeneral::callVoidFunction(', "\n";
   print '         "streamsx.ec", "_set_tl_opc", this->pyop_->opc(), NULL);', "\n";
   print "\n";
   print '     PyObject *tmp_instance = SplpyGeneral::pyObject_Call(callable, empty_tuple, param_dict);', "\n";
   print '     Py_DECREF(callable);', "\n";
   print '     if (tmp_instance == NULL) {', "\n";
   print '         SPLAPPTRC(L_ERROR, "Fatal error: cannot create instance of class " << "';
   print $functionName;
   print '" << " in module " << "';
   print $module;
   print '", "python");', "\n";
   print '        SplpyGeneral::callVoidFunction(', "\n";
   print '            "streamsx.ec", "_clear_tl_opc", NULL, NULL);', "\n";
   print '         throw SplpyGeneral::pythonException("';
   print $module;
   print '");', "\n";
   print '     }', "\n";
   print '     SplpyGeneral::callVoidFunction(', "\n";
   print '         "streamsx.ec", "_clear_tl_opc", NULL, NULL);', "\n";
   print '   ', "\n";
   print '     callable = tmp_instance;', "\n";
   print '   }', "\n";
       }
   print "\n";
    if (not $skip_set_callable) { 
   print "\n";
   print '     this->pyop_->setCallable(callable);', "\n";
   print '     this->pyop_->setup(SPLPY_CALLABLE_STATE_HANDLER);', "\n";
    } 
   print "\n";
   print "\n";
   print '    }', "\n";
   print "\n";
    if ($model->getNumberOfInputPorts() != 0) { 
   print "\n";
   print '{', "\n";
   print '   SplpyGIL lock;', "\n";
   
   my @portParamStyles = splpy_ParamStyle();
   my @portFixedParam = splpy_FixedParam();
   
   for (my $p = 0; $p < $model->getNumberOfInputPorts(); $p++) {
   
   my $iport = $model->getInputPortAt($p);
   
   my $paramStyle = @portParamStyles[$p];
   my $fixedParam = @portFixedParam[$p];
   
   if ($fixedParam != -1) {
       if ($fixedParam > $iport->getNumberOfAttributes()) {
          SPL::CodeGen::exitln('%s requires at least %i attributes in input port %i but schema is %s',
              $model->getContext()->getKind(), $fixedParam, $iport->getIndex(), $iport->getSPLTupleType());
    }
   }
   
   my $ppn = "";
   if ($p >= 1) {
      $ppn = $p;
   }
   
   if ($paramStyle eq 'dictionary') { 
   print "\n";
   print '      pyInNames_';
   print $ppn;
   print ' = streamsx::topology::Splpy::pyAttributeNames(', "\n";
   print '               getInputPortAt(';
   print $p;
   print '));', "\n";
   }}
   print "\n";
   print "\n";
   print '   // callFunction takes a reference.', "\n";
   print '   Py_INCREF(callable);', "\n";
   print '   pyinputfns_ = SplpyGeneral::callFunction(', "\n";
   print '             "streamsx.spl.runtime", "_splpy_primitive_input_fns",', "\n";
   print '             callable, NULL);   ', "\n";
   print '}', "\n";
   print "\n";
    } 
   print "\n";
   print "\n";
    if ($model->getNumberOfOutputPorts() != 0) { 
   print "\n";
   print '{', "\n";
   print '    SplpyGIL lock;', "\n";
     for (my $p = 0; $p < $model->getNumberOfOutputPorts(); $p++) { 
   print "\n";
   print '    pyOutNames_';
   print $p;
   print ' = Splpy::pyAttributeNames(getOutputPortAt(';
   print $p;
   print '));', "\n";
   }
   print "\n";
   print '}', "\n";
   }
   print "\n";
   print "\n";
   print '}', "\n";
   print "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::allPortsReady()', "\n";
   print '{', "\n";
   print '    createThreads(1);', "\n";
   print '}', "\n";
   print "\n";
   print '/**', "\n";
   print '  Call the Python class\'s all_ports_ready method', "\n";
   print '  if it exists and use the return to block for', "\n";
   print '  completion of outstanding work. If this', "\n";
   print '  operator has no output ports then it will', "\n";
   print '  complete when this function (thread) returns.', "\n";
   print '*/', "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::process(uint32_t idx)', "\n";
   print '{', "\n";
   print '   if (getPE().getShutdownRequested())', "\n";
   print '       return;', "\n";
   print "\n";
   print '   PyObject *blocker = NULL;', "\n";
   print "\n";
   print '   {', "\n";
   print '     SplpyGIL lock;', "\n";
   print "\n";
   print '     Py_INCREF(pyop_->callable());', "\n";
   print '     blocker = SplpyGeneral::callFunction(', "\n";
   print '             "streamsx.spl.runtime", "_splpy_all_ports_ready",', "\n";
   print '             pyop_->callable(), NULL);', "\n";
   print "\n";
   print '     bool callable = (bool) PyCallable_Check(blocker);', "\n";
   print '     if (!callable) {', "\n";
   print '         int has_background_work = PyObject_IsTrue(blocker);', "\n";
   print '         Py_DECREF(blocker);', "\n";
   print '         blocker = NULL;', "\n";
   print '         ', "\n";
   print '         if (has_background_work == 0)', "\n";
   print '             return;', "\n";
   print '     }', "\n";
   print '   }', "\n";
   print "\n";
   print '   if (blocker == NULL) {', "\n";
   print '       getPE().blockUntilShutdownRequest();', "\n";
   print '   } else {', "\n";
   print '       if (getPE().getShutdownRequested())', "\n";
   print '           return;', "\n";
   print "\n";
   print '       SplpyGIL lock;', "\n";
   print "\n";
   print '       PyObject *rv = SplpyGeneral::pyCallObject(blocker, NULL);', "\n";
   print '       Py_DECREF(rv);', "\n";
   print '       Py_DECREF(blocker);', "\n";
   print '   }', "\n";
   print '}', "\n";
   print "\n";
   print 'MY_OPERATOR_SCOPE::MY_OPERATOR::~MY_OPERATOR() ', "\n";
   print '{', "\n";
   print '   SplpyGIL lock;', "\n";
   print '   {', "\n";
   if ($model->getNumberOfInputPorts() != 0) {
   print "\n";
   print '   Py_CLEAR(pyinputfns_);', "\n";
   print '   Py_CLEAR(pyInNames_);', "\n";
     for (my $p = 1; $p < $model->getNumberOfInputPorts(); $p++) { 
   print "\n";
   print '       Py_CLEAR(pyInNames_';
   print $p;
   print ');', "\n";
   }}
   print "\n";
     for (my $p = 0; $p < $model->getNumberOfOutputPorts(); $p++) { 
   print "\n";
   print '       Py_CLEAR(pyOutNames_';
   print $p;
   print ');', "\n";
   }
   print "\n";
   print '   }', "\n";
   print '   delete pyop_;', "\n";
   print '}', "\n";
   print "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::prepareToShutdown() ', "\n";
   print '{', "\n";
   print '    pyop_->prepareToShutdown();', "\n";
   print '}', "\n";
   print "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::process(Tuple const & tuple, uint32_t port)', "\n";
   print '{', "\n";
   print '	AutoPortMutex apm(_mutex, *this);', "\n";
   if ($model->getNumberOfInputPorts() != 0) {
   my @portParamStyles = splpy_ParamStyle();
   my @portFixedParam = splpy_FixedParam();
   
   for (my $p = 0; $p < $model->getNumberOfInputPorts(); $p++) {
   
     my $iport = $model->getInputPortAt($p);
     my $paramStyle = @portParamStyles[$p];
     my $fixedParam = @portFixedParam[$p];
     my $inputAttrs2Py = $iport->getNumberOfAttributes();
     if ($fixedParam != -1) {
       $inputAttrs2Py = $fixedParam;
     }
   
     if ($model->getNumberOfInputPorts() > 1) {
   print "\n";
   print '      if (port == ';
   print $p;
   print ')', "\n";
     }
   
   print "\n";
   print ' try {', "\n";
   print ' // Code block for a single port', "\n";
   # Perl Variables that need to be set:
   #
   # $iport - input port 
   #
   # $inputAttrs2Py - number of attributes to pass as tuple style
   #
   
      #Check if a blob exists in the input schema
      for (my $i = 0; $i < $inputAttrs2Py; ++$i) {
         if (typeHasBlobs($iport->getAttributeAt($i)->getSPLType())) {
   print "\n";
   print '   PYSPL_MEMORY_VIEW_CLEANUP();', "\n";
            last;
         }
      }
   print "\n";
   print "\n";
   print '    SplpyGIL lock;', "\n";
   print "\n";
   {
   # Takes the input SPL tuple and converts it to
   # the arguments needed to be passed to a Python
   # function/callable decorated as a SPL operator.
   
   # Variables that need to be set:
   
   # $paramStyle - tuple or dictionary
   # $iport - input port 
   # $inputAttrs2Py - number of attributes to pass as tuple style
   
   my $ipt = $iport->getCppTupleType();
   my $ipv = $iport->getCppTupleName();
   
   print "\n";
   print "\n";
   print '   ';
   print $ipt;
   print ' const & ';
   print $ipv;
   print ' = static_cast< ';
   print $ipt;
   print ' const &>(tuple);', "\n";
   print "\n";
       if ($paramStyle eq 'tuple') {
   print "\n";
   print '// START-Processing passing SPL tuple as a Python tuple', "\n";
   print '// Declares: PyObject * pyTuple ', "\n";
   print '// Declares: PyObject * pyDict as NULL', "\n";
   print "\n";
   print '    PyObject *pyDict = NULL; ', "\n";
   print '    PyObject * pyTuple = PyTuple_New(';
   print $inputAttrs2Py;
   print ');', "\n";
   print '    PyObject *pyValue;', "\n";
        for (my $i = 0; $i < $inputAttrs2Py; ++$i) {
            my $la = $iport->getAttributeAt($i);
            print convertToPythonValueAsTuple($ipv, $i, $la->getSPLType(), $la->getName());
        }
   print "\n";
   print '// END-Processing passing SPL tuple as a Python tuple', "\n";
       }
   print "\n";
   print "\n";
       if ($paramStyle eq 'dictionary') {
   print "\n";
   print '// START-Processing passing SPL tuple as a Python dictionary', "\n";
   print '// All attributes are passed in the dictionary', "\n";
   print '// Declares: PyObject * pyTuple as empty tuple', "\n";
   print '// Declares: PyObject * pyDict', "\n";
   print "\n";
   print '    PyObject * pyTuple = PyTuple_New(0);', "\n";
   print '    PyObject * pyDict = PyDict_New();', "\n";
        my $ppn = '';
        if ($iport->getIndex() >= 1) {
            $ppn = $iport->getIndex();
        }
   
        for (my $i = 0; $i < $iport->getNumberOfAttributes(); ++$i) {
            my $la = $iport->getAttributeAt($i);
            print convertAndAddToPythonDictionaryObject($ipv, $i, $la->getSPLType(), $la->getName(), 'pyInNames_' . $ppn, 'pyDict', "    ", $model->getContext()->getOutputDirectory());
        }
   print "\n";
   print '// END-Processing passing SPL tuple as a Python dictionary', "\n";
       }
   }
   print "\n";
   print "\n";
   print "\n";
   print '    PyObject *fn = PyList_GET_ITEM(pyinputfns_, (Py_ssize_t) ';
   print $p;
   print ');', "\n";
   print '    PyObject * pyReturnVar = SplpyGeneral::pyObject_Call(fn, pyTuple, pyDict);', "\n";
   print "\n";
   print '    if (pyReturnVar == NULL) {', "\n";
   print '        throw SplpyExceptionInfo::pythonError("';
   print $functionName;
   print '");', "\n";
   print '    }', "\n";
   print '    Py_DECREF(pyReturnVar);', "\n";
   print "\n";
   print '    return;', "\n";
   print ' } catch (const streamsx::topology::SplpyExceptionInfo& excInfo) {', "\n";
   print '    SPLPY_OP_HANDLE_EXCEPTION_INFO_GIL(excInfo);', "\n";
   print '    return;', "\n";
   print ' }', "\n";
   print "\n";
   }}
   print "\n";
   print '}', "\n";
   print "\n";
   print '// Create member functions that convert Python tuple to SPL tuple', "\n";
   print '// for each port.', "\n";
   for (my $p = 0; $p < $model->getNumberOfOutputPorts(); $p++) {
       my $oport = $model->getOutputPortAt($p);
       my $oport_submission = 1;
       my $iport = undef;
   print "\n";
   #
   # Creates a function pySubmitTuplesN that takes a Python value
   # and submits tuples to the output port. The value
   # must be a Python tuple or a list[tuple].
   # Calls the generated function fromPythonToPort0
   #
   # $oport - output port to submit to
   # $iport - optional - input port to copy attributes from.
   #
   {
     my $itypeparam = "";
     my $ituplearg = "";
     if (defined $iport) {
        $itypeparam = ", " . $iport->getCppTupleType() . " const & ituple";
        $ituplearg = ", ituple";
     }
   print "\n";
   print "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::pySubmitTuplesPort';
   print $oport->getIndex();
   print '(PyObject *value ';
   print $itypeparam;
   print ') {', "\n";
   print "\n";
   print "\n";
   print '  if (PyTuple_Check(value))', "\n";
   print '  {', "\n";
   print '    ';
   print $oport->getCppTupleType();
   print ' otuple;', "\n";
   print '    fromPythonToPort';
   print $oport->getIndex();
   print '(value, otuple ';
   print $ituplearg;
   print ');', "\n";
   print '  }', "\n";
   print '  else if (PyDict_Check(value)) {', "\n";
   print '    ';
   print $oport->getCppTupleType();
   print ' otuple;', "\n";
   print '    fromPythonDictToPort';
   print $oport->getIndex();
   print '(value, otuple ';
   print $ituplearg;
   print ');', "\n";
   print '  }', "\n";
   print '  else if (PyList_Check(value))', "\n";
   print '  {', "\n";
   print "\n";
   print '     /* Logic for if a list of tuples is returned */', "\n";
   print '     Py_ssize_t tc = PyList_GET_SIZE(value);', "\n";
   print '     for (Py_ssize_t k = 0; k < tc; k++) {    ', "\n";
   print '       PyObject *ltuple = PyList_GET_ITEM(value, k);', "\n";
   print '       if (SplpyGeneral::isNone(ltuple))', "\n";
   print '           continue;', "\n";
   print '       ';
   print $oport->getCppTupleType();
   print ' otuple;', "\n";
   print '       if (PyTuple_Check(ltuple)) {    ', "\n";
   print '           fromPythonToPort';
   print $oport->getIndex();
   print '(ltuple, otuple ';
   print $ituplearg;
   print ');', "\n";
   print '       } else if (PyDict_Check(ltuple)) {', "\n";
   print '           fromPythonDictToPort';
   print $oport->getIndex();
   print '(ltuple, otuple ';
   print $ituplearg;
   print ');', "\n";
   print '       } else {', "\n";
   print '          throw SplpyGeneral::generalException("submit",', "\n";
   print '             "Fatal error: Value submitted must be a Python tuple, dict or list of tuples or dicts: Port ';
   print $oport->getIndex();
   print '");', "\n";
   print '       }', "\n";
   print '     ', "\n";
   print '     }', "\n";
   print '  }', "\n";
   print '  else {', "\n";
   print '     throw SplpyGeneral::generalException("submit",', "\n";
   print '        "Fatal error: Value submitted must be a Python tuple, dict or a Python list of tuples or dicts: Port ';
   print $oport->getIndex();
   print '");', "\n";
   print '  }', "\n";
   print '}', "\n";
   }
   print "\n";
   # Generates functions in an operator that converts a Python
   # tuple to an SPL tuple for a given port and optional to
   # submit the tuple.
   #
   # $oport must be set on entry to required output port
   # $oport_submission must be set on entry to generate submission methods.
   # $iport can be set to automatically copy input attributes to
   # output attributes when the Python tuple does not supply a value.
   
     my $itypeparam = "";
     my $itypearg = "";
     if (defined $iport) {
        $itypeparam = ", " . $iport->getCppTupleType() . " const & ituple";
        $itypearg = ", ituple";
     }
   print "\n";
   print "\n";
    if ($oport_submission) { 
   print "\n";
   print ' ', "\n";
   print '// Python tuple to SPL tuple with submission to a port', "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::fromPythonToPort';
   print $oport->getIndex();
   print '(PyObject *pyTuple, ';
   print $oport->getCppTupleType();
   print ' & otuple ';
   print $itypeparam;
   print ') {', "\n";
   print "\n";
   print '  try {', "\n";
   print '    MY_OPERATOR_SCOPE::MY_OPERATOR::fromPyTupleToSPLTuple(pyTuple, otuple ';
   print $itypearg;
   print ');', "\n";
   print '  } catch (const streamsx::topology::SplpyExceptionInfo& excInfo) {', "\n";
   print '    SPLPY_OP_HANDLE_EXCEPTION_INFO(excInfo);', "\n";
   print '    return;', "\n";
   print '  }', "\n";
   print "\n";
   print '  STREAMSX_TUPLE_SUBMIT_ALLOW_THREADS(otuple, ';
   print $oport->getIndex();
   print ');', "\n";
   print '}', "\n";
   print "\n";
   print '// Python dict to SPL tuple with submission to a port.', "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::fromPythonDictToPort';
   print $oport->getIndex();
   print '(PyObject *pyDict, ';
   print $oport->getCppTupleType();
   print ' & otuple ';
   print $itypeparam;
   print ') {', "\n";
   print "\n";
   print '  try {', "\n";
   print '    MY_OPERATOR_SCOPE::MY_OPERATOR::fromPyDictToSPLTuple(pyDict, otuple ';
   print $itypearg;
   print ');', "\n";
   print '  } catch (const streamsx::topology::SplpyExceptionInfo& excInfo) {', "\n";
   print '    SPLPY_OP_HANDLE_EXCEPTION_INFO(excInfo);', "\n";
   print '    return;', "\n";
   print '  }', "\n";
   print "\n";
   print '  STREAMSX_TUPLE_SUBMIT_ALLOW_THREADS(otuple, ';
   print $oport->getIndex();
   print ');', "\n";
   print '}', "\n";
   print "\n";
   }
   print "\n";
   print "\n";
   # Ensure we generate function only once for each tuple type
   my $otype = $oport->getCppTupleType();
   if (! exists $cpp_tuple_types{$otype}) {
       $cpp_tuple_types{$otype} = 1;
   print "\n";
   print "\n";
   print '// Python tuple to SPL tuple , conversion only', "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::fromPyTupleToSPLTuple(PyObject *pyTuple, ';
   print $oport->getCppTupleType();
   print ' & otuple  ';
   print $itypeparam;
   print ') {', "\n";
   print "\n";
   print '  Py_ssize_t frs = PyTuple_GET_SIZE(pyTuple); ', "\n";
   print '    ', "\n";
     if (defined $iport) {
       print 'bool setAttr = false;';
     }
     my $spaces = '                  ';
     # handle nested tuples __NESTED_TUPLE__
     sub convertNestedPythonTupleToSpl {
       my $otuple = $_[0];
       my $atype = $_[1];
       my $spaces = $_[2];
       my $output_dir = $_[3]; # $model->getContext()->getOutputDirectory()
       my $gencode;
       $gencode = "\n";
       $gencode = $gencode . $spaces . "{\n";
       $gencode = $gencode . $spaces . "  PyObject *pyTuple = pyAttrValue;\n";
       my @attrTypes = SPL::CodeGen::Type::getAttributeTypes ($atype);
       my $i=0;
       for my $attrName (SPL::CodeGen::Type::getAttributeNames ($atype)) {
       $gencode = $gencode . $spaces . "  // $attrName - $attrTypes[$i]\n";
       $gencode = $gencode . $spaces . "  {\n";
       $gencode = $gencode . $spaces . "    PyObject *pyAttrValue = PyTuple_GET_ITEM(pyTuple, $i);\n";
       $gencode = $gencode . $spaces . "    if (!SplpyGeneral::isNone(pyAttrValue)) {\n";
           if (SPL::CodeGen::Type::isTuple($attrTypes[$i])) {
       $gencode = $gencode . $spaces . "      // tuple type: $attrName - $attrTypes[$i]\n";    
       $gencode = $gencode . $spaces . "      " . convertNestedPythonTupleToSpl($otuple.'.get_'.$attrName.'()', $attrTypes[$i], $spaces.'      ', $output_dir) . "\n";
           }
           elsif ((SPL::CodeGen::Type::isMap($attrTypes[$i])) && (SPL::CodeGen::Type::isTuple(SPL::CodeGen::Type::getValueType($attrTypes[$i])))) {          
       $gencode = $gencode . $spaces . "      // NOT IMPLEMENTED: map with tuple as value type: $attrName - $attrTypes[$i]\n";
           }
           elsif ((SPL::CodeGen::Type::isMap($attrTypes[$i])) && (SPL::CodeGen::Type::isList(SPL::CodeGen::Type::getValueType($attrTypes[$i]))) && (SPL::CodeGen::Type::isTuple(SPL::CodeGen::Type::getElementType(SPL::CodeGen::Type::getValueType($attrTypes[$i]))))) {          
       $gencode = $gencode . $spaces . "      // NOT SUPPORTED: map with list of tuple as value type: $attrName - $attrTypes[$i]\n";
             SPL::CodeGen::errorln("SPL type: " . $attrTypes[$i] . " is not supported for conversion from Python.");
           }
           elsif ((SPL::CodeGen::Type::isList($attrTypes[$i])) && (SPL::CodeGen::Type::isTuple(SPL::CodeGen::Type::getElementType($attrTypes[$i])))) {
             my $element_type = SPL::CodeGen::Type::getElementType($attrTypes[$i]);
       $gencode = $gencode . $spaces . "      // list of tuple: $attrName - $element_type\n";
       $gencode = $gencode . $spaces . "      int list_size = (int)PyList_Size(pyAttrValue);\n";
       $gencode = $gencode . $spaces . "      for (int list_index = 0; list_index < list_size; ++list_index) {\n";
       $gencode = $gencode . $spaces . "        " . spl_cpp_type($attrName, 'SPL::list', $element_type, $model->getContext()->getOutputDirectory()) . " se; // retrieve cpp type of tuple from generated header files\n";
       $gencode = $gencode . $spaces . "        $otuple.get_$attrName().add(se); // add tuple to list\n";
       $gencode = $gencode . $spaces . "        PyObject* v = PyList_GET_ITEM(pyAttrValue, list_index);\n";
       $gencode = $gencode . $spaces . "        " . convertNestedPythonTupleToSpl($otuple.'.get_'.$attrName.'()[list_index]', SPL::CodeGen::Type::getElementType($attrTypes[$i]), $spaces.'        ', $output_dir) . "\n";
       $gencode = $gencode . $spaces . "      }\n";    
           }
           else {                        
       $gencode = $gencode . $spaces . "      streamsx::topology::pySplValueFromPyObject($otuple.get_$attrName(), pyAttrValue);\n";
           }
       $gencode = $gencode . $spaces . "    }\n";
       $gencode = $gencode . $spaces . "  }\n";
           $i++;
       }
       $gencode = $gencode . $spaces . "}\n";
       return $gencode;
   }
   
     for (my $ai = 0; $ai < $oport->getNumberOfAttributes(); ++$ai) {
       
       my $attribute = $oport->getAttributeAt($ai);
       my $name = $attribute->getName();
       my $atype = $attribute->getSPLType();
       splToPythonConversionCheck($atype);
       
       if (defined $iport) {
                print 'setAttr = false;';
       }
   print "\n";
   print '    if (';
   print $ai;
   print ' < frs) {', "\n";
   print '         // Value from the Python function', "\n";
   print '         PyObject *pyAttrValue = PyTuple_GET_ITEM(pyTuple, ';
   print $ai;
   print ');', "\n";
   print '         if (!SplpyGeneral::isNone(pyAttrValue)) {', "\n";
   print '         ';
   my $nested_tuple = 0;
   print "\n";
   print '         ';
   if (SPL::CodeGen::Type::isList($atype)) {
                my $element_type = SPL::CodeGen::Type::getElementType($atype);  
                if (SPL::CodeGen::Type::isTuple($element_type)) {
   print ' ', "\n";
   print '             ';
   $nested_tuple = 1;
   print "\n";
   print '             // list of tuple ';
   print $name;
   print ' - ';
   print $element_type;
   print "\n";
   print '             int list_size = (int)PyList_Size(pyAttrValue);', "\n";
   print '             for (int list_index = 0; list_index < list_size; ++list_index) {', "\n";
   print '                 ';
   print spl_cpp_type($name, 'SPL::list', $element_type, $model->getContext()->getOutputDirectory());
   print ' se; // retrieve cpp type of tuple from generated header files', "\n";
   print '                 otuple.get_';
   print $name;
   print '().add(se); // add tuple to list', "\n";
   print '                 PyObject* v = PyList_GET_ITEM(pyAttrValue, list_index);', "\n";
   print '                 ';
   print(convertNestedPythonTupleToSpl('otuple.get_'.$name.'()[list_index]', $element_type, $spaces.'', $model->getContext()->getOutputDirectory()));
   print "\n";
   print '             }', "\n";
   print '           ';
   }
   print "\n";
   print '         ';
   }
   print ' ', "\n";
   print '         ';
   if (SPL::CodeGen::Type::isMap($atype)) {
                if (SPL::CodeGen::Type::isTuple(SPL::CodeGen::Type::getValueType($atype))) {
                  $nested_tuple = 1;
   print '    ', "\n";
   print '             // NOT IMPLEMENTED: map with tuple as value type ';
   print $name;
   print ' - ';
   print $atype;
   print "\n";
   print '           ';
   } elsif (SPL::CodeGen::Type::isList(SPL::CodeGen::Type::getValueType($atype))) {
                     my $element_type = SPL::CodeGen::Type::getElementType(SPL::CodeGen::Type::getValueType($atype));  
                     if (SPL::CodeGen::Type::isTuple($element_type)) {
                       $nested_tuple = 1;
                       SPL::CodeGen::errorln("SPL type: " . $atype . " is not supported for conversion from Python.");
   print ' ', "\n";
   print '             // NOT SUPPORTED: map of list of tuple ';
   print $name;
   print ' ';
   print $atype;
   print '                ', "\n";
   print '                ';
   }
   print "\n";
   print '            ';
   }
   print "\n";
   print '         ';
   }
   print "\n";
   print '         ';
   if (SPL::CodeGen::Type::isTuple($atype)) {
   print "\n";
   print '           ';
   $nested_tuple = 1;
   print "\n";
   print '             // tuple type ';
   print $name;
   print ' - ';
   print $atype;
   print "\n";
   print '             ';
   print(convertNestedPythonTupleToSpl('otuple.get_'.$name.'()', $atype, $spaces.'', $model->getContext()->getOutputDirectory()));
   print "\n";
   print '           ';
   }
   print "\n";
   print '         ';
   if ($nested_tuple == 0) {
   print "\n";
   print '             streamsx::topology::pySplValueFromPyObject(otuple.get_';
   print $name;
   print '(), pyAttrValue);', "\n";
   print '         ';
   }
   print "\n";
       if (defined $iport) {
                print 'setAttr = true;';
       }
   print "\n";
   print '         }', "\n";
   print '    }', "\n";
       if (defined $iport) {
       
       # Only copy attributes across if they match on name and type,
       # or on name and input type T and output type optional<T>
       my $matchInputAttr = $iport->getAttributeByName($name);
       if (defined $matchInputAttr) {
           my $inputType = $matchInputAttr->getSPLType();
           if (($inputType eq $atype) ||
               (hasOptionalTypesSupport() &&
                SPL::CodeGen::Type::isOptional($atype) &&
                ($inputType eq
                 SPL::CodeGen::Type::getUnderlyingType($atype)))) {
   print "\n";
   print '    if (!setAttr) {', "\n";
   print '      // value from the input attribute', "\n";
   print '      otuple.set_';
   print $name;
   print '(ituple.get_';
   print $name;
   print '());', "\n";
   print '    }', "\n";
         }
       }
      }
   print "\n";
   print '         ', "\n";
   }
    
   print "\n";
   print "\n";
   print '}', "\n";
   print "\n";
   print "\n";
   print '// Python dict to SPL tuple , conversion only', "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::fromPyDictToSPLTuple(PyObject *pyDict, ';
   print $oport->getCppTupleType();
   print ' & otuple  ';
   print $itypeparam;
   print ') {', "\n";
   print "\n";
   print '  Py_ssize_t available = PyDict_Size(pyDict); ', "\n";
   print '    ', "\n";
     if (defined $iport) {
       print 'bool setAttr = false;';
     }
     my $spaces = '                  ';
     # handle nested tuples __NESTED_TUPLE__
     sub convertNestedPythonDictionaryToSpl {
         my $otuple = $_[0];
         my $atype = $_[1];
         my $spaces = $_[2];
         my $output_dir = $_[3]; # $model->getContext()->getOutputDirectory()
   
         my $gencode;
         $gencode = "\n";
         $gencode = $gencode . $spaces . "{\n";
         $gencode = $gencode . $spaces . "  PyObject *value = v;\n";
         $gencode = $gencode . $spaces . "  PyObject *k,*v;\n";
         $gencode = $gencode . $spaces . "  Py_ssize_t pos = 0;\n";
         $gencode = $gencode . $spaces . "  while (PyDict_Next(value, &pos, &k, &v)) {\n";
         $gencode = $gencode . $spaces . "    if (v != NULL) {\n";
         $gencode = $gencode . $spaces . "      if (!SplpyGeneral::isNone(v)) {\n";
         my @attrTypes = SPL::CodeGen::Type::getAttributeTypes ($atype);
         my $i=0;
         my $nested=0;
         for my $attrName (SPL::CodeGen::Type::getAttributeNames ($atype)) {
       	  $i++;
       	  $nested=0;
         $gencode = $gencode . $spaces . "          // attribute: $attrName - type: $attrTypes[$i-1]\n";   	  
             if (SPL::CodeGen::Type::isTuple($attrTypes[$i-1])) {
           	$nested=1;
         $gencode = $gencode . $spaces . "          if (pos == $i) { // attribute=$attrName\n";
         $gencode = $gencode . $spaces . "            // tuple type: $attrTypes[$i-1]\n";    
         $gencode = $gencode . $spaces . "            " . convertNestedPythonDictionaryToSpl($otuple.'.get_'.$attrName.'()', $attrTypes[$i-1], $spaces.'            ', $output_dir) . "\n";
         $gencode = $gencode . $spaces . "          }\n";
             }
             if (SPL::CodeGen::Type::isMap($attrTypes[$i-1])) {
               my $valueType = SPL::CodeGen::Type::getValueType($attrTypes[$i-1]);
               if (SPL::CodeGen::Type::isTuple($valueType)) {
                 $nested=1;
                 if ($otuple eq 'sv') {
                   SPL::CodeGen::errorln("SPL type: " . $atype . " is not supported for conversion from Python.");
                 }
         $gencode = $gencode . $spaces . "          if (pos == $i) { // attribute=$attrName\n";
         $gencode = $gencode . $spaces . "            // map with tuple as value type: $attrTypes[$i-1] - $valueType\n";
         $gencode = $gencode . $spaces . "            // SPL map from Python dictionary\n";
         $gencode = $gencode . $spaces . "            PyObject *value = v;\n";
         $gencode = $gencode . $spaces . "            PyObject *k,*v;\n";
         $gencode = $gencode . $spaces . "            Py_ssize_t pos = 0;\n";
         $gencode = $gencode . $spaces . "            while (PyDict_Next(value, &pos, &k, &v)) {\n";
         $gencode = $gencode . $spaces . "              ".SPL::CodeGen::Type::getKeyType($attrTypes[$i-1])." sk; // key type\n";
         $gencode = $gencode . $spaces . "              // Set the SPL key\n";
         $gencode = $gencode . $spaces . "              pySplValueFromPyObject(sk, k);\n";
         $gencode = $gencode . $spaces . "              // map[] creates the value if it does not exist\n";
         $gencode = $gencode . $spaces . "              ".spl_cpp_type($attrName, 'SPL::map', SPL::CodeGen::Type::getValueType($attrTypes[$i-1]), $output_dir)." & sv = ".$otuple.".get_".$attrName."()[sk];\n";
         $gencode = $gencode . $spaces . "              // Set the SPL value for value type\n";
         $gencode = $gencode . $spaces . "             ".convertNestedPythonDictionaryToSpl('sv', SPL::CodeGen::Type::getValueType($attrTypes[$i-1]), $spaces.'              ', $output_dir)."\n";
         $gencode = $gencode . $spaces . "            }\n";
         $gencode = $gencode . $spaces . "          }\n";
               }
               elsif (SPL::CodeGen::Type::isList($valueType)) {
                 my $elementType = SPL::CodeGen::Type::getElementType($attrTypes[$i-1]);
                 if (SPL::CodeGen::Type::isTuple($elementType)) {
                   $nested=1;
                   SPL::CodeGen::errorln("SPL type: " . $atype . " is not supported for conversion from Python.");
         $gencode = $gencode . $spaces . "          if (pos == $i) { // attribute=$attrName\n";
         $gencode = $gencode . $spaces . "            // map with list of tuple as value type: $attrTypes[$i-1] - $valueType\n";           
         $gencode = $gencode . $spaces . "          }\n";     
                 }
               }
             }
             if (SPL::CodeGen::Type::isList($attrTypes[$i-1])) {
           	my $elementType = SPL::CodeGen::Type::getElementType($attrTypes[$i-1]);
               if (SPL::CodeGen::Type::isTuple($elementType)) {
                 $nested=1;
                 if ($otuple eq 'sv') {
                   SPL::CodeGen::errorln("SPL type: " . $atype . " is not supported for conversion from Python.");
                 }
         $gencode = $gencode . $spaces . "          if (pos == $i) { // attribute=$attrName\n";
         $gencode = $gencode . $spaces . "            // list of tuple: $attrTypes[$i-1] - $elementType\n";
         $gencode = $gencode . $spaces . "            PyObject *value = v;\n";
         $gencode = $gencode . $spaces . "            int list_size = (int)PyList_Size(value);\n";
         $gencode = $gencode . $spaces . "            for (int list_index = 0; list_index < list_size; ++list_index) {\n";
         $gencode = $gencode . $spaces . "              ".spl_cpp_type($attrName, 'SPL::list', $elementType, $output_dir)." se; // retrieve cpp type of tuple from generated header files\n";
         $gencode = $gencode . $spaces . "              $otuple.get_$attrName().add(se); // add tuple to list\n";
         $gencode = $gencode . $spaces . "              PyObject* v = PyList_GET_ITEM(value, list_index);\n";
         $gencode = $gencode . $spaces . "             ".convertNestedPythonDictionaryToSpl($otuple.'.get_'.$attrName.'()[list_index]', $elementType, $spaces.'              ', $output_dir)."\n";
         $gencode = $gencode . $spaces . "            }\n";      
         $gencode = $gencode . $spaces . "          }\n";
               }
             }
             if (0 == $nested) {                        
         $gencode = $gencode . $spaces . "          if (pos == $i) { // attribute=$attrName\n";
         $gencode = $gencode . $spaces . "            // $attrTypes[$i-1]\n";
         $gencode = $gencode . $spaces . "            streamsx::topology::pySplValueFromPyObject($otuple.get_$attrName(), v);\n";
         $gencode = $gencode . $spaces . "          }\n";
             }
         }
         $gencode = $gencode . $spaces . "      }\n";
         $gencode = $gencode . $spaces . "    }\n";
         $gencode = $gencode . $spaces . "  }\n";
         $gencode = $gencode . $spaces . "}\n";
         return $gencode;
     }
   
     for (my $ai = $oport->getNumberOfAttributes() - 1; $ai >= 0; --$ai) {
       my $attribute = $oport->getAttributeAt($ai);
       my $name = $attribute->getName();
       my $atype = $attribute->getSPLType();
       splToPythonConversionCheck($atype);
       
       if (defined $iport) {
                print 'setAttr = false;';
       }
   print "\n";
   print '    // attribute name=';
   print $name;
   print ' type=';
   print $atype;
   print "\n";
   print '    if (available > 0) {', "\n";
   print '         // Value from the Python function', "\n";
   print '         PyObject *pyAttrValue = PyDict_GetItem(pyDict, PyTuple_GET_ITEM(pyOutNames_';
   print $oport->getIndex();
   print ', ';
   print $ai;
   print '));', "\n";
   print '         if (pyAttrValue != NULL) {', "\n";
   print '             --available;', "\n";
   print '             if (!SplpyGeneral::isNone(pyAttrValue)) {', "\n";
   print '               ';
   my $nested_tuple = 0;
   print "\n";
   print '               ';
   if (SPL::CodeGen::Type::isList($atype)) {
                      my $element_type = SPL::CodeGen::Type::getElementType($atype);  
                      if (SPL::CodeGen::Type::isTuple($element_type)) {
   print "\n";
   print '                     ';
   $nested_tuple = 1;
   print "\n";
   print '                  // list of tuple: ';
   print $name;
   print ' - ';
   print $element_type;
   print "\n";
   print '                  int list_size = (int)PyList_Size(pyAttrValue);', "\n";
   print '                  for (int list_index = 0; list_index < list_size; ++list_index) {', "\n";
   print '                      ';
   print spl_cpp_type($name, 'SPL::list', $element_type, $model->getContext()->getOutputDirectory());
   print ' se; // retrieve cpp type of tuple from generated header files', "\n";
   print '                      otuple.get_';
   print $name;
   print '().add(se); // add tuple to list', "\n";
   print '                      PyObject* v = PyList_GET_ITEM(pyAttrValue, list_index);', "\n";
   print '                      ';
   print(convertNestedPythonDictionaryToSpl('otuple.get_'.$name.'()[list_index]', $element_type, $spaces."          ", $model->getContext()->getOutputDirectory()));
   print "\n";
   print '                  }', "\n";
   print '                 ';
   }
   print "\n";
   print '               ';
   }
   print ' ', "\n";
   print '               ';
   if (SPL::CodeGen::Type::isMap($atype)) {
                      if (SPL::CodeGen::Type::isTuple(SPL::CodeGen::Type::getValueType($atype))) {
                        $nested_tuple = 1;
   print '    ', "\n";
   print '                  // map of tuple: ';
   print $name;
   print ' ';
   print $atype;
   print "\n";
   print '                  // SPL map from Python dictionary', "\n";
   print '                  PyObject *value = pyAttrValue;', "\n";
   print '                  PyObject *k,*v;', "\n";
   print '                  Py_ssize_t pos = 0;', "\n";
   print '                  while (PyDict_Next(value, &pos, &k, &v)) {', "\n";
   print '                      ';
   print SPL::CodeGen::Type::getKeyType($atype);
   print ' sk; // key type', "\n";
   print '                      // Set the SPL key', "\n";
   print '                      pySplValueFromPyObject(sk, k);', "\n";
   print '                      // map[] creates the value if it does not exist', "\n";
   print '                      ';
   print spl_cpp_type($name, 'SPL::map', SPL::CodeGen::Type::getValueType($atype), $model->getContext()->getOutputDirectory());
   print ' & sv = otuple.get_';
   print $name;
   print '()[sk];', "\n";
   print '                      // Set the SPL value for value type ';
   print SPL::CodeGen::Type::getValueType($atype);
   print "\n";
   print '                      ';
   print(convertNestedPythonDictionaryToSpl('sv', SPL::CodeGen::Type::getValueType($atype), $spaces."    ", $model->getContext()->getOutputDirectory()));
   print "\n";
   print '                  }', "\n";
   print '                 ';
   } elsif (SPL::CodeGen::Type::isList(SPL::CodeGen::Type::getValueType($atype))) {
                        my $element_type = SPL::CodeGen::Type::getElementType(SPL::CodeGen::Type::getValueType($atype));
                        if (SPL::CodeGen::Type::isTuple($element_type)) {
                          $nested_tuple = 1;
                          SPL::CodeGen::errorln("SPL type: " . $atype . " is not supported for conversion from Python.");
   print "\n";
   print '                  // NOT SUPPORTED: map of list of tuple: ';
   print $name;
   print ' ';
   print $atype;
   print "\n";
   print '                   ';
   }
   print "\n";
   print '                 ';
   }
   print "\n";
   print '               ';
   }
   print "\n";
   print '               ';
   if (SPL::CodeGen::Type::isTuple($atype)) {
   print "\n";
   print '                  ';
   $nested_tuple = 1;
   print "\n";
   print '                  // tuple type: ';
   print $name;
   print ' - ';
   print $atype;
   print "\n";
   print '                  PyObject *value = pyAttrValue;', "\n";
   print '                  PyObject *k,*v;', "\n";
   print '                  Py_ssize_t pos = 0;', "\n";
   print '                  while (PyDict_Next(value, &pos, &k, &v)) {', "\n";
   print '                    if (v != NULL) {', "\n";
   print '                      if (!SplpyGeneral::isNone(v)) {', "\n";
   print '                      ';
   my @attrTypes = SPL::CodeGen::Type::getAttributeTypes ($atype);
   print "\n";
   print '                      ';
   my $i=0; for my $attrName (SPL::CodeGen::Type::getAttributeNames ($atype)) { $i++;
   print "\n";
   print '                        ';
   if (SPL::CodeGen::Type::isTuple($attrTypes[$i-1])) {
   print "\n";
   print '                        if (pos == ';
   print $i;
   print ') { // attribute=';
   print $attrName;
   print "\n";
   print '                          // tuple type: ';
   print $attrTypes[$i-1];
   print "\n";
   print '                          ';
   print(convertNestedPythonDictionaryToSpl('otuple.get_'.$name.'().get_'.$attrName.'()', $attrTypes[$i-1], $spaces."        ", $model->getContext()->getOutputDirectory()));
   print "\n";
   print '                        }', "\n";
   print '                        ';
   } elsif ((SPL::CodeGen::Type::isList($attrTypes[$i-1])) && (SPL::CodeGen::Type::isTuple(SPL::CodeGen::Type::getElementType($attrTypes[$i-1])))) {
   print "\n";
   print '                        if (pos == ';
   print $i;
   print ') { // attribute=';
   print $attrName;
   print '  ', "\n";
   print '                           ';
   my $element_type = SPL::CodeGen::Type::getElementType($attrTypes[$i-1]);
   print "\n";
   print '                           PyObject *value = v;', "\n";
   print '                           // list of tuple: ';
   print $attrName;
   print ' - ';
   print $element_type;
   print "\n";
   print '                           int list_size = (int)PyList_Size(value);', "\n";
   print '                           for (int list_index = 0; list_index < list_size; ++list_index) {', "\n";
   print '                               ';
   print spl_cpp_type($attrName, 'SPL::list', $element_type, $model->getContext()->getOutputDirectory());
   print ' se; // retrieve cpp type of tuple from generated header files', "\n";
   print '                               otuple.get_';
   print $name;
   print '().get_';
   print $attrName;
   print '().add(se); // add tuple to list', "\n";
   print '                               PyObject* v = PyList_GET_ITEM(value, list_index);', "\n";
   print '                               ';
   print(convertNestedPythonDictionaryToSpl('otuple.get_'.$name.'().get_'.$attrName.'()[list_index]', $element_type, $spaces."          ", $model->getContext()->getOutputDirectory()));
   print "\n";
   print '                           }', "\n";
   print '                        }', "\n";
   print '                        ';
   } elsif ((SPL::CodeGen::Type::isMap($attrTypes[$i-1])) && (SPL::CodeGen::Type::isTuple(SPL::CodeGen::Type::getValueType($attrTypes[$i-1])))) {
   print "\n";
   print '                        if (pos == ';
   print $i;
   print ') { // attribute=';
   print $attrName;
   print "\n";
   print '                            // map with tuple as value type: ';
   print $attrName;
   print ' - ';
   print $attrTypes[$i-1];
   print "\n";
   print '                            // SPL map from Python dictionary', "\n";
   print '                            PyObject *value = v;', "\n";
   print '                            PyObject *k,*v;', "\n";
   print '                            Py_ssize_t pos = 0;', "\n";
   print '                            while (PyDict_Next(value, &pos, &k, &v)) {', "\n";
   print '                                ';
   print SPL::CodeGen::Type::getKeyType($attrTypes[$i-1]);
   print ' sk; // key type', "\n";
   print '                                // Set the SPL key', "\n";
   print '                                pySplValueFromPyObject(sk, k);', "\n";
   print '                                // map[] creates the value if it does not exist ';
   print SPL::CodeGen::Type::getValueType($attrTypes[$i-1]);
   print "\n";
   print '                                ';
   print spl_cpp_type($attrName, 'SPL::map', SPL::CodeGen::Type::getValueType($attrTypes[$i-1]), $model->getContext()->getOutputDirectory());
   print ' & sv = otuple.get_';
   print $name;
   print '().get_';
   print $attrName;
   print '()[sk];', "\n";
   print '                                // Set the SPL value for value type', "\n";
   print '                                ';
   print(convertNestedPythonDictionaryToSpl('sv', SPL::CodeGen::Type::getValueType($attrTypes[$i-1]), $spaces."              ", $model->getContext()->getOutputDirectory()));
   print "\n";
   print '                            }', "\n";
   print '                        }', "\n";
   print '                        ';
   } elsif ((SPL::CodeGen::Type::isMap($attrTypes[$i-1])) && (SPL::CodeGen::Type::isList(SPL::CodeGen::Type::getValueType($attrTypes[$i-1]))) && (SPL::CodeGen::Type::isTuple(SPL::CodeGen::Type::getElementType(SPL::CodeGen::Type::getValueType($attrTypes[$i-1]))))) {
   print "\n";
   print '                        if (pos == ';
   print $i;
   print ') { // attribute=';
   print $attrName;
   print "\n";
   print '                        	';
   SPL::CodeGen::errorln("SPL type: " . $attrTypes[$i-1] . " is not supported for conversion from Python.");
   print "\n";
   print '                            // NOT SUPPORTED: map with list of tuple as value type: $attrName - $attrTypes[$i]\\n";', "\n";
   print '                        }', "\n";
   print '                        ';
   } else {
   print '                        ', "\n";
   print '                        if (pos == ';
   print $i;
   print ') { // attribute=';
   print $attrName;
   print "\n";
   print '                          // ';
   print $attrTypes[$i-1];
   print "\n";
   print '                          streamsx::topology::pySplValueFromPyObject(otuple.get_';
   print $name;
   print '().get_';
   print $attrName;
   print '(), v);', "\n";
   print '                        }', "\n";
   print '                        ';
   }
   print "\n";
   print '                      ';
   }
   print "\n";
   print '                      }', "\n";
   print '                    }', "\n";
   print '                  }', "\n";
   print '               ';
   }
   print "\n";
   print '               ';
   if ($nested_tuple == 0) {
   print "\n";
   print '                  // ';
   print $name;
   print ' - ';
   print $atype;
   print "\n";
   print '                  streamsx::topology::pySplValueFromPyObject(otuple.get_';
   print $name;
   print '(), pyAttrValue);', "\n";
   print '               ';
   }
   print "\n";
       if (defined $iport) {
                print 'setAttr = true;';
       }
   print "\n";
   print '           }', "\n";
   print '        }', "\n";
   print '    }', "\n";
       if (defined $iport) {
       
       # Only copy attributes across if they match on name and type
       my $matchInputAttr = $iport->getAttributeByName($name);
       if (defined $matchInputAttr) {
          if ($matchInputAttr->getSPLType() eq $attribute->getSPLType()) {
   print "\n";
   print '    if (!setAttr) {', "\n";
   print '      // value from the input attribute', "\n";
   print '      otuple.set_';
   print $name;
   print '(ituple.get_';
   print $name;
   print '());', "\n";
   print '    }', "\n";
         }
       }
      }
   print "\n";
   print '         ', "\n";
   }
    
   print "\n";
   print '}', "\n";
    } 
   print "\n";
    } 
   print "\n";
   print "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::convertAndSubmit(uint32_t port, PyObject *tuple_) {', "\n";
   print '     if (SplpyGeneral::isNone(tuple_)) {', "\n";
   print '          Py_DECREF(tuple_);', "\n";
   print '          return;', "\n";
   print '     }', "\n";
    for (my $p = 0; $p < $model->getNumberOfOutputPorts(); $p++) { 
   print "\n";
   print '     if (port == ';
   print $p;
   print ')', "\n";
   print '         pySubmitTuplesPort';
   print $p;
   print '(tuple_);', "\n";
   }
   print "\n";
   print '}', "\n";
   print "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::process(Punctuation const & punct, uint32_t port) {', "\n";
   print '    AutoPortMutex apm(_mutex, *this);', "\n";
   print '    if (punct == Punctuation::WindowMarker) {', "\n";
   print '        PyObject *pyObjOnPunct = NULL;', "\n";
   print '        SplpyGIL lock;', "\n";
   print '        Py_INCREF(pyop_->callable());', "\n";
   print '        pyObjOnPunct = SplpyGeneral::callFunction("streamsx.spl.runtime", "_splpy_on_punct", pyop_->callable(), NULL);', "\n";
   print '        bool callable = (bool) PyCallable_Check(pyObjOnPunct);', "\n";
   print '        if (callable) {', "\n";
   print '            PyObject *rv = SplpyGeneral::pyCallObject(pyObjOnPunct, NULL);', "\n";
   print '            Py_DECREF(rv);', "\n";
   print '            Py_DECREF(pyObjOnPunct);', "\n";
   print '        }', "\n";
   print '        else if (NULL != pyObjOnPunct) {', "\n";
   print '            Py_DECREF(pyObjOnPunct);', "\n";
   print '        }', "\n";
   print '    }', "\n";
   print '}', "\n";
   print "\n";
   print 'void MY_OPERATOR_SCOPE::MY_OPERATOR::submitPunct(uint32_t port) {', "\n";
    for (my $p = 0; $p < $model->getNumberOfOutputPorts(); $p++) { 
   print "\n";
   print '     if (port == ';
   print $p;
   print ')', "\n";
   print '         submit (Punctuation::WindowMarker, ';
   print $p;
   print ');', "\n";
   }
   print "\n";
   print '}', "\n";
   print "\n";
   SPL::CodeGen::implementationEpilogue($model);
   print "\n";
   CORE::exit $SPL::CodeGen::USER_ERROR if ($SPL::CodeGen::sawError);
}
1;
